package de.dfki.mlt.advent2022;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

class Day01 {

  private static final Logger logger = LoggerFactory.getLogger(Day01.class);

  static int firstTask(Path path) throws IOException {

    List<String> lines = Files.readAllLines(path);

    int maxCount = Integer.MIN_VALUE;
    int currentCount = 0;
    for (String oneLine : lines) {
      logger.debug(oneLine);
      if (oneLine.isEmpty()) {
        if (currentCount > maxCount) {
          maxCount = currentCount;
          logger.debug("new max count now is: {}", maxCount);
        }
        currentCount = 0;
      } else {
        currentCount += Integer.parseInt(oneLine);
        logger.debug("current count now is: {}", currentCount);
      }
    }
    if (currentCount > maxCount) {
      maxCount = currentCount;
    }

    logger.info("Task 1: max count: {}", maxCount);
    return maxCount;
  }

  static int secondTask(Path path) throws IOException {

    List<String> lines = Files.readAllLines(path);

    List<Integer> counts = new ArrayList<>();
    int currentCount = 0;
    for (String oneLine : lines) {
      logger.debug(oneLine);
      if (oneLine.isEmpty()) {
        counts.add(currentCount);
        currentCount = 0;
      } else {
        currentCount += Integer.parseInt(oneLine);
        logger.debug("current count now is: {}", currentCount);
      }
    }
    counts.add(currentCount);

    Collections.sort(counts);
    Collections.reverse(counts);
    int maxCount = counts.get(0) + counts.get(1) + counts.get(2);

    logger.info("Task 2: max count: {}", maxCount);
    return maxCount;
  }
}
