package de.dfki.mlt.advent2022;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

class Day03 {

  private static final Logger logger = LoggerFactory.getLogger(Day03.class);

  private static String allChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

  static int charToPriority(char c) {
    return allChars.indexOf(c) + 1;
  }

  static int firstTask(Path path) throws IOException {

    List<String> lines = Files.readAllLines(path);

    int totalPrio = 0;
    for (String oneLine : lines) {
      logger.debug(oneLine);
      String compartment1 = oneLine.substring(0, oneLine.length() / 2);
      String compartment2 = oneLine.substring(oneLine.length() / 2);
      for (char c : compartment1.toCharArray()) {
        if (compartment2.indexOf(c) != -1) {
          int prio = charToPriority(c);
          logger.debug("adding prio of {} for {}", prio, c);
          totalPrio += charToPriority(c);
          break;
        }
      }
    }

    logger.info("task 1 total prio: {}", totalPrio);
    return totalPrio;
  }

  static int secondTask(Path path) throws IOException {

    List<String> lines = Files.readAllLines(path);

    int totalPrio = 0;
    for (int i = 0; i < lines.size(); i = i + 3) {
      String rucksack1 = lines.get(i);
      String rucksack2 = lines.get(i + 1);
      String rucksack3 = lines.get(i + 2);
      for (char c : rucksack1.toCharArray()) {
        if (rucksack2.indexOf(c) != -1 && rucksack3.indexOf(c) != -1) {
          logger.debug("found {} in all three rucksacks", c);
          totalPrio += charToPriority(c);
          break;
        }
      }
    }

    logger.info("task 2 total prio: {}", totalPrio);
    return totalPrio;
  }
}
